<template lang="pug">

mixin ParamList
  ParamList.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)
    if block
      block

mixin Param
  Param.col-12.col-sm-6.col-lg-4.col-xl-2&attributes(attributes)
    if block
      block

Collapsible(ref='collapsible')
  template(v-slot:header='collapsible')
    .row
      .col-6.col-md-3
        strong #[i.fa.fa-filter] Zero Suppression
      AnimBlock(anim='fade')
        .col-6(v-if='!collapsible.isExpanded && zsp') {{ getModeText(activeZsp.mode) }}
  .col-12(v-if='isLoading')
    i.fa.fa-spinner.fa-pulse
  .col-12(v-else)
    .row(v-if="zsp")
      +ParamList(v-if='zsp' ref='mode' title='mode'
                 :options='$options.modes' :inEdit='inEdit' :value='zsp.mode'
                 @edit='zspEdit && zspEdit.setMode($event)')
      +ParamList(v-if='activeZsp.mode === ZSPMode.SINGLE_MASTER' title='master'
                 :value='firstMaster' :options='masterChoiceList' :inEdit='inEdit'
                 @edit='zspEdit && zspEdit.setSingleMaster($event)')
      .col-12.mt-1(v-if='activeZsp.mode === ZSPMode.MASTER')
        .row.my-3.py-2.border.border-primary.bg-light.rounded(v-for='master in activeZsp.master')
          +Param(value='master' :key='master.id' :title='getChanName(master)'
                 :readonly='true' :inEdit='inEdit')
            template(v-slot:title)
              strong {{ getChanName(master) }}
              span.small {{ getChanInfo(master) }}
          +ParamList(v-for='chan in master.slave'
                     :key='chan.id' :title='getChanName(chan)' :value='chan.masterId'
                     :options='masterChoiceList' :inEdit='inEdit'
                     @edit='zspEdit && zspEdit.moveSlave(chan, $event)')
            template(v-slot:title)
              strong {{ getChanName(chan) }}
              span.small {{ getChanInfo(chan) }}
        .row.my-1.py-1.shadow.rounded(v-if='channels && !$butils.isEmpty(activeZsp.indep)')
          .col-12
            strong Independent
          +ParamList(v-for='chan in activeZsp.indep' value=''
                     :key='chan.id' :title='getChanName(chan)'
                     :options='filteredMasterChoice(chan)' :inEdit='inEdit'
                     @edit='zspEdit && zspEdit.moveSlave(chan, $event)')
            template(v-slot:title)
              strong {{ getChanName(chan) }}
              span.small {{ getChanInfo(chan) }}
        .row.my-1.py-1.shadow.rounded(v-if="!channels")
          .col-12
            | #[i.fa.fa-spinner.fa-pulse] Loading ...
</template>
<script>
export { default } from './AppZeroSuppression.vue.js';
</script>
